/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { ProvenanceDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { ProvenanceForUpdateDto } from '../../@coscine/model';
/**
 * ProvenanceApi - axios parameter creator
 * @export
 */
export const ProvenanceApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {string} resourceId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions: async (projectId: string, resourceId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('apiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('apiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/provenance`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the specific provenance information associated with a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {string} path Gets or sets the path of the metadata tree.
         * @param {number} [version] Gets or sets the desired version.  If the version is null, the newest will be returned.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getSpecificProvenance: async (projectId: string, resourceId: string, path: string, version?: number, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getSpecificProvenance', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('getSpecificProvenance', 'resourceId', resourceId)
            // verify required parameter 'path' is not null or undefined
            assertParamExists('getSpecificProvenance', 'path', path)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/provenance/specific`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (path !== undefined) {
                localVarQueryParameter['Path'] = path;
            }

            if (version !== undefined) {
                localVarQueryParameter['Version'] = version;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Updates existing specific provenance information of a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {ProvenanceForUpdateDto} [provenanceForUpdateDto] The updated provenance information.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateSpecificProvenance: async (projectId: string, resourceId: string, provenanceForUpdateDto?: ProvenanceForUpdateDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('updateSpecificProvenance', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('updateSpecificProvenance', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/provenance/specific`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(provenanceForUpdateDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ProvenanceApi - functional programming interface
 * @export
 */
export const ProvenanceApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ProvenanceApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {string} resourceId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions(projectId: string, resourceId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions(projectId, resourceId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProvenanceApi.apiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves the specific provenance information associated with a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {string} path Gets or sets the path of the metadata tree.
         * @param {number} [version] Gets or sets the desired version.  If the version is null, the newest will be returned.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getSpecificProvenance(projectId: string, resourceId: string, path: string, version?: number, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProvenanceDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getSpecificProvenance(projectId, resourceId, path, version, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProvenanceApi.getSpecificProvenance']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Updates existing specific provenance information of a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {ProvenanceForUpdateDto} [provenanceForUpdateDto] The updated provenance information.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateSpecificProvenance(projectId: string, resourceId: string, provenanceForUpdateDto?: ProvenanceForUpdateDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateSpecificProvenance(projectId, resourceId, provenanceForUpdateDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProvenanceApi.updateSpecificProvenance']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ProvenanceApi - factory interface
 * @export
 */
export const ProvenanceApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ProvenanceApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {ProvenanceApiApiV2ProjectsProjectIdResourcesResourceIdProvenanceOptionsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions(requestParameters: ProvenanceApiApiV2ProjectsProjectIdResourcesResourceIdProvenanceOptionsRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions(requestParameters.projectId, requestParameters.resourceId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the specific provenance information associated with a resource.
         * @param {ProvenanceApiGetSpecificProvenanceRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getSpecificProvenance(requestParameters: ProvenanceApiGetSpecificProvenanceRequest, options?: RawAxiosRequestConfig): AxiosPromise<ProvenanceDtoResponse> {
            return localVarFp.getSpecificProvenance(requestParameters.projectId, requestParameters.resourceId, requestParameters.path, requestParameters.version, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Updates existing specific provenance information of a resource.
         * @param {ProvenanceApiUpdateSpecificProvenanceRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateSpecificProvenance(requestParameters: ProvenanceApiUpdateSpecificProvenanceRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.updateSpecificProvenance(requestParameters.projectId, requestParameters.resourceId, requestParameters.provenanceForUpdateDto, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions operation in ProvenanceApi.
 * @export
 * @interface ProvenanceApiApiV2ProjectsProjectIdResourcesResourceIdProvenanceOptionsRequest
 */
export interface ProvenanceApiApiV2ProjectsProjectIdResourcesResourceIdProvenanceOptionsRequest {
    /**
     * 
     * @type {string}
     * @memberof ProvenanceApiApiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions
     */
    readonly projectId: string

    /**
     * 
     * @type {string}
     * @memberof ProvenanceApiApiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions
     */
    readonly resourceId: string
}

/**
 * Request parameters for getSpecificProvenance operation in ProvenanceApi.
 * @export
 * @interface ProvenanceApiGetSpecificProvenanceRequest
 */
export interface ProvenanceApiGetSpecificProvenanceRequest {
    /**
     * The unique identifier or slug of the project.
     * @type {string}
     * @memberof ProvenanceApiGetSpecificProvenance
     */
    readonly projectId: string

    /**
     * The unique identifier of the resource.
     * @type {string}
     * @memberof ProvenanceApiGetSpecificProvenance
     */
    readonly resourceId: string

    /**
     * Gets or sets the path of the metadata tree.
     * @type {string}
     * @memberof ProvenanceApiGetSpecificProvenance
     */
    readonly path: string

    /**
     * Gets or sets the desired version.  If the version is null, the newest will be returned.
     * @type {number}
     * @memberof ProvenanceApiGetSpecificProvenance
     */
    readonly version?: number
}

/**
 * Request parameters for updateSpecificProvenance operation in ProvenanceApi.
 * @export
 * @interface ProvenanceApiUpdateSpecificProvenanceRequest
 */
export interface ProvenanceApiUpdateSpecificProvenanceRequest {
    /**
     * The unique identifier or slug of the project.
     * @type {string}
     * @memberof ProvenanceApiUpdateSpecificProvenance
     */
    readonly projectId: string

    /**
     * The unique identifier of the resource.
     * @type {string}
     * @memberof ProvenanceApiUpdateSpecificProvenance
     */
    readonly resourceId: string

    /**
     * The updated provenance information.
     * @type {ProvenanceForUpdateDto}
     * @memberof ProvenanceApiUpdateSpecificProvenance
     */
    readonly provenanceForUpdateDto?: ProvenanceForUpdateDto
}

/**
 * ProvenanceApi - object-oriented interface
 * @export
 * @class ProvenanceApi
 * @extends {BaseAPI}
 */
export class ProvenanceApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {ProvenanceApiApiV2ProjectsProjectIdResourcesResourceIdProvenanceOptionsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProvenanceApi
     */
    public apiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions(requestParameters: ProvenanceApiApiV2ProjectsProjectIdResourcesResourceIdProvenanceOptionsRequest, options?: RawAxiosRequestConfig) {
        return ProvenanceApiFp(this.configuration).apiV2ProjectsProjectIdResourcesResourceIdProvenanceOptions(requestParameters.projectId, requestParameters.resourceId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the specific provenance information associated with a resource.
     * @param {ProvenanceApiGetSpecificProvenanceRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProvenanceApi
     */
    public getSpecificProvenance(requestParameters: ProvenanceApiGetSpecificProvenanceRequest, options?: RawAxiosRequestConfig) {
        return ProvenanceApiFp(this.configuration).getSpecificProvenance(requestParameters.projectId, requestParameters.resourceId, requestParameters.path, requestParameters.version, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Updates existing specific provenance information of a resource.
     * @param {ProvenanceApiUpdateSpecificProvenanceRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProvenanceApi
     */
    public updateSpecificProvenance(requestParameters: ProvenanceApiUpdateSpecificProvenanceRequest, options?: RawAxiosRequestConfig) {
        return ProvenanceApiFp(this.configuration).updateSpecificProvenance(requestParameters.projectId, requestParameters.resourceId, requestParameters.provenanceForUpdateDto, options).then((request) => request(this.axios, this.basePath));
    }
}

